import { OnInit, EventEmitter } from '@angular/core';
export declare class ContextMenuItem {
    title: string;
    onSelect: (sender: TreePickerNode, index: number) => JQueryPromise<TreePickerNode>;
    isEnable: (sender: TreePickerNode, index: number) => boolean;
    iconClass: string;
    constructor(title: string, onSelect: (sender: TreePickerNode, index: number) => JQueryPromise<TreePickerNode>, isEnable: (sender: TreePickerNode, index: number) => boolean, iconClass: string);
}
export declare class TreePickerNode {
    title: string;
    hoverText: string;
    isExpanded: boolean;
    isSelected: boolean;
    children: Array<TreePickerNode>;
    parent: TreePickerNode;
    domainObj: any;
}
export interface ITreePickerScope {
    nodes: Array<TreePickerNode>;
    contextMenuActions: Array<ContextMenuItem>;
    onNodeSelected: (sender: TreePickerNode) => void;
    onNodeSelecting: (node: TreePickerNode, callBack: (options?: any) => void) => void;
    nodeWithContextMenu: TreePickerNode;
    showContextMenu: boolean;
    onDblClickNode: (sender: TreePickerNode) => void;
    selectingNode: () => void;
    selectNode: (sender: TreePickerNode) => void;
    selectContextMenuItem: (sender: ContextMenuItem, node: TreePickerNode, index: number) => void;
    isContextMenuItemDisable: (sender: ContextMenuItem, node: TreePickerNode, index: number) => boolean;
    expandedIconClass: string;
    collapsedIconClass: string;
    itemIconClass: string;
    dblClickNode: (sender: TreePickerNode) => void;
}
export declare class TreePicker implements OnInit {
    nodes: Array<TreePickerNode>;
    contextMenuActions: Array<ContextMenuItem>;
    onNodeSelected: Function;
    onNodeSelecting: Function;
    expandedIconClass: string;
    collapsedIconClass: string;
    itemIconClass: string;
    showContextMenu: boolean;
    onDblClickNode: Function;
    nodesChange: EventEmitter<Array<TreePickerNode>>;
    contextMenuActionsChange: EventEmitter<Array<ContextMenuItem>>;
    static templateGuid: string;
    private scope;
    constructor();
    ngOnInit(): void;
    link: () => void;
}
export declare class TreePickerTemplate {
    static templateId: string;
    item: TreePickerNode;
    selectNode: Function;
    showContextMenu: boolean;
    isContextMenuItemDisable: boolean;
    selectContextMenuItem: Function;
    contextMenuActions: Array<ContextMenuItem>;
    expandedIconClass: string;
    collapsedIconClass: string;
    itemIconClass: string;
    nodeIndex: any;
    dblClickNode: Function;
}
